#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>
#include <String.h>
#include "Trap.h"
#include "rhc_oid.h"
#include <string.h>

using namespace std;

Trap::Trap(oid trap_oid[], size_t trap_len)
{
	my_vars = NULL;

	Add(snmp_trap, snmp_trap_len, trap_oid, trap_len);
}

Trap::~Trap()
{
	snmp_free_varbind(my_vars);
	my_vars = NULL;
}

int
Trap::Add(oid o[], size_t o_len, int data)
{
	if (snmp_varlist_add_variable(&my_vars, o, o_len,
				ASN_INTEGER,
				(u_char *)&data,
				sizeof(data)) == NULL);
		return 1;
	return 0;
}

int
Trap::Add(oid o[], size_t o_len, oid data[], size_t data_len)
{
	if (snmp_varlist_add_variable(&my_vars, o, o_len,
				ASN_OBJECT_ID,
				(u_char *)data,
				data_len * sizeof(oid)) == NULL)
		return 1;
	return 0;
}

int
Trap::Add(oid o[], size_t o_len, String data)
{
	if (snmp_varlist_add_variable(&my_vars, o, o_len,
				ASN_OCTET_STR,
				(u_char *)(data.c_str()),
				data.size()) == NULL)
		return 1;
	return 0;
}

int
Trap::Add(oid o[], size_t o_len, const char *data)
{
	if (snmp_varlist_add_variable(&my_vars, o, o_len,
				ASN_OCTET_STR,
				(u_char *)(data),
				strlen(data)) == NULL)
		return 1;
	return 0;
}

void
Trap::Send()
{
	send_v2trap(my_vars);
}


