#include <net-snmp/net-snmp-config.h>
#include <net-snmp/net-snmp-includes.h>
#include <net-snmp/agent/net-snmp-agent-includes.h>

/* NOTE: rhc_oid.cpp is used for automatic generation of rhc_oid.h;
 * utilize the same format when editing rhc_oid.cpp */

/* SNMP OIDs we need to know about */
oid snmp_trap[]				= { 1, 3, 6, 1, 6, 3, 1, 1, 4, 1, 0 };
size_t snmp_trap_len			= OID_LENGTH(snmp_trap);

/* Traps */
oid rhcConfigVersion_trap[]		= { 1, 3, 6, 1, 4, 1, 2312, 8, 0, 1 };
size_t rhcConfigVersion_len		= OID_LENGTH(rhcConfigVersion_trap);

oid rhcQuorumState_trap[]		= { 1, 3, 6, 1, 4, 1, 2312, 8, 0, 2 };
size_t rhcQuorumState_len		= OID_LENGTH(rhcQuorumState_trap);

oid rhcNodeState_trap[]			= { 1, 3, 6, 1, 4, 1, 2312, 8, 0, 3 };
size_t rhcNodeState_len			= OID_LENGTH(rhcNodeState_trap);

oid rhcServiceState_trap[]		= { 1, 3, 6, 1, 4, 1, 2312, 8, 0, 4 };
size_t rhcServiceState_len		= OID_LENGTH(rhcServiceState_trap);

/* Objects */
oid rhcMIBVersion_oid[]			= { 1, 3, 6, 1, 4, 1, 2312, 8, 1, 1 };
size_t rhcMIBVersion_len		= OID_LENGTH(rhcMIBVersion_oid);

oid rhcClusterName_oid[]		= { 1, 3, 6, 1, 4, 1, 2312, 8, 2, 1 };
size_t rhcClusterName_len		= OID_LENGTH(rhcClusterName_oid);

oid rhcClusterStatusCode_oid[]		= { 1, 3, 6, 1, 4, 1, 2312, 8, 2, 2 };
size_t rhcClusterStatusCode_len		= OID_LENGTH(rhcClusterStatusCode_oid);

oid rhcClusterStatusDesc_oid[]		= { 1, 3, 6, 1, 4, 1, 2312, 8, 2, 3 };
size_t rhcClusterStatusDesc_len		= OID_LENGTH(rhcClusterStatusDesc_oid);

oid rhcClusterVotesNeededForQuorum_oid[] = { 1, 3, 6, 1, 4, 1, 2312, 8, 2, 4 };
size_t rhcClusterVotesNeededForQuorum_len = OID_LENGTH(rhcClusterVotesNeededForQuorum_oid);

oid rhcClusterVotes_oid[]		= { 1, 3, 6, 1, 4, 1, 2312, 8, 2, 5 };
size_t rhcClusterVotes_len		= OID_LENGTH(rhcClusterVotes_oid);

oid rhcClusterQuorate_oid[]		= { 1, 3, 6, 1, 4, 1, 2312, 8, 2, 6 };
size_t rhcClusterQuorate_len		= OID_LENGTH(rhcClusterQuorate_oid);

oid rhcClusterNodesNum_oid[]		= { 1, 3, 6, 1, 4, 1, 2312, 8, 2, 7 };
size_t rhcClusterNodesNum_len		= OID_LENGTH(rhcClusterNodesNum_oid);

oid rhcClusterNodesNames_oid[]		= { 1, 3, 6, 1, 4, 1, 2312, 8, 2, 8 };
size_t rhcClusterNodesNames_len		= OID_LENGTH(rhcClusterNodesNames_oid);

oid rhcClusterAvailNodesNum_oid[]	= { 1, 3, 6, 1, 4, 1, 2312, 8, 2, 9 };
size_t rhcClusterAvailNodesNum_len	= OID_LENGTH(rhcClusterAvailNodesNum_oid);

oid rhcClusterAvailNodesNames_oid[]	= { 1, 3, 6, 1, 4, 1, 2312, 8, 2, 10 };
size_t rhcClusterAvailNodesNames_len	= OID_LENGTH(rhcClusterAvailNodesNames_oid);

oid rhcClusterUnavailNodesNum_oid[]	= { 1, 3, 6, 1, 4, 1, 2312, 8, 2, 11 };
size_t rhcClusterUnavailNodesNum_len	= OID_LENGTH(rhcClusterUnavailNodesNum_oid);

oid rhcClusterUnavailNodesNames_oid[]	= { 1, 3, 6, 1, 4, 1, 2312, 8, 2, 12 };
size_t rhcClusterUnavailNodesNames_len	= OID_LENGTH(rhcClusterUnavailNodesNames_oid);

oid rhcClusterServicesNum_oid[]		= { 1, 3, 6, 1, 4, 1, 2312, 8, 2, 13 };
size_t rhcClusterServicesNum_len	= OID_LENGTH(rhcClusterServicesNum_oid);

oid rhcClusterServicesNames_oid[]	= { 1, 3, 6, 1, 4, 1, 2312, 8, 2, 14 };
size_t rhcClusterServicesNames_len	= OID_LENGTH(rhcClusterServicesNames_oid);

oid rhcClusterRunningServicesNum_oid[]	= { 1, 3, 6, 1, 4, 1, 2312, 8, 2, 15 };
size_t rhcClusterRunningServicesNum_len	= OID_LENGTH(rhcClusterRunningServicesNum_oid);

oid rhcClusterRunningServicesNames_oid[] = { 1, 3, 6, 1, 4, 1, 2312, 8, 2, 16 };
size_t rhcClusterRunningServicesNames_len = OID_LENGTH(rhcClusterRunningServicesNames_oid);

oid rhcClusterStoppedServicesNum_oid[]	= { 1, 3, 6, 1, 4, 1, 2312, 8, 2, 17 };
size_t rhcClusterStoppedServicesNum_len	= OID_LENGTH(rhcClusterStoppedServicesNum_oid);

oid rhcClusterStoppedServicesNames_oid[] = { 1, 3, 6, 1, 4, 1, 2312, 8, 2, 18 };
size_t rhcClusterStoppedServicesNames_len = OID_LENGTH(rhcClusterStoppedServicesNames_oid);

oid rhcClusterFailedServicesNum_oid[]	= { 1, 3, 6, 1, 4, 1, 2312, 8, 2, 19 };
size_t rhcClusterFailedServicesNum_len	= OID_LENGTH(rhcClusterFailedServicesNum_oid);

oid rhcClusterFailedServicesNames_oid[]	= { 1, 3, 6, 1, 4, 1, 2312, 8, 2, 20 };
size_t rhcClusterFailedServicesNames_len = OID_LENGTH(rhcClusterFailedServicesNames_oid);

oid rhcClusterConfigVersion_oid[]	= { 1, 3, 6, 1, 4, 1, 2312, 8, 2, 21 };
size_t rhcClusterConfigVersion_len	= OID_LENGTH(rhcClusterConfigVersion_oid);

/* Tables */
oid rhcNodesTable_oid[]			= { 1, 3, 6, 1, 4, 1, 2312, 8, 3, 1 };
size_t rhcNodesTable_len		= OID_LENGTH(rhcNodesTable_oid);

oid rhcServicesTable_oid[]		= { 1, 3, 6, 1, 4, 1, 2312, 8, 3, 2 };
size_t rhcServicesTable_len		= OID_LENGTH(rhcServicesTable_oid);
